<template>
  <v-btn x-small color="grey lighten-4" outlined @click="handleTests">
    EHQ
    <v-icon small right>mdi-file-document-outline</v-icon>
    <!-- DIALOG DE LOGIN EHQ -->
    <v-dialog v-model="dialogEhq" max-width="600px">
      <v-row justify="center" no-gutters>
        <v-card style="width: 100%">
          <v-toolbar style="position:relative" color="white" elevation="0">
            <v-spacer />
            <v-toolbar-title class="mt-5">
              <span class="primary--text">
                <v-icon large color="primary" class="mr-2 pb-1">mdi-file-document-outline</v-icon
                ><b>Plataforma de Avaliações</b>
              </span>
            </v-toolbar-title>
            <v-spacer />
            <v-tooltip color="red" bottom>
              <template v-slot:activator="{ on }">
                <v-icon
                  v-on="on"
                  style="position:absolute; right: 15px"
                  color="red"
                  @click="dialogEhq = false"
                  >mdi-close</v-icon
                >
              </template>
              <span><b>Fechar</b> janela</span>
            </v-tooltip>
          </v-toolbar>
          <v-card-text align="center">
            Olá, você está tentando acessar o módulo de avaliações do Polvo. <br />
            Por favor, <b>realize o login novamente</b>.
          </v-card-text>
          <v-card-text>
            <v-card-actions>
              <v-row justify="center">
                <v-col cols="12" align="center">
                  <v-text-field
                    class="mt-n4"
                    outlined
                    prepend-inner-icon="mdi-account"
                    style="max-width: 70%"
                    v-model="loginEhq.login"
                    label="Login"
                    @keydown.enter="login"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" align="center">
                  <v-text-field
                    class="mt-n6"
                    outlined
                    prepend-inner-icon="mdi-key-variant"
                    style="max-width: 70%"
                    v-model="loginEhq.password"
                    type="password"
                    label="Senha"
                    @keydown.enter="login"
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-card-actions>
            <v-card-actions v-if="incorrectLogin" class="mt-n8 mb-6">
              <v-row justify="center" class="red--text text--lighten-2">
                Login e/ou senha estão incorretos, por favor tente novamente!
              </v-row>
            </v-card-actions>
            <v-card-actions class="mt-n3 pb-5">
              <v-row justify="center">
                <v-btn color="primary" elevation="0" @click="login">Entrar</v-btn>
              </v-row>
            </v-card-actions>
          </v-card-text>
        </v-card>
      </v-row>
    </v-dialog>
  </v-btn>
</template>

<script>
import Login from '../../servicesEhq/req/open'

export default {
  name: 'TestButton',
  components: {},
  data: () => ({
    loginEhq: { login: '', password: '' },
    dialogEhq: false,
    incorrectLogin: false,
  }),
  computed: {
    activeEntityUrl() {
      return '/entity/' + this.$route.params.entityName
    },
  },
  methods: {
    async handleTests() {
      const ehqAccessKey = await this.$getItem('accessKeyEHQ')
      const ehqAuth = await this.$getItem('authenticationKeyEHQ')

      if (ehqAccessKey && ehqAuth) {
        //já está logado
        this.$router.push(`${this.activeEntityUrl}/ehq/`).catch((err) => {})
      } else {
        //não está logado
        this.dialogEhq = true
      }
    },

    async login() {
      let data = { login: this.loginEhq.login, password: this.loginEhq.password }

      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Login.login(data)
        if (req.success) {
          //add accessKey, authenticationKey e infos -> no localForage
          await this.$setItem('accessKeyEHQ', req.data.accessKey)
          await this.$setItem('authenticationKeyEHQ', req.data.authenticationKey)
          await this.$setItem('userEHQ', {
            id: req.data.id,
            type: req.data.type,
            name: req.data.name,
            surname: req.data.surname,
            email: req.data.email,
          })

          this.loginEhq = { login: '', password: '' }
          this.dialogEhq = false
          this.incorrectLogin = false
          this.$router.push(`${this.activeEntityUrl}/ehq/`).catch((err) => {})
        } else {
          this.incorrectLogin = true
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
  },
}
</script>
